> For the complete documentation index, see [llms.txt](https://developer.vario-software.de/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://developer.vario-software.de/api-reference/scripting.md).

# Scripting

Access scripting modules, TypeScript declarations, run logs and deprecation data through the VARIO Cloud Scripting API.

Script management

## GET /cmn/scripting/typescript-declarations

>

```json
{"openapi":"3.1.0","info":{"title":"OpenAPI definition","version":"2026.42.0"},"tags":[{"name":"Scripting","description":"Script management"}],"servers":[{"url":"api.example.com"}],"paths":{"/cmn/scripting/typescript-declarations":{"get":{"tags":["Scripting"],"operationId":"getTypeScriptDeclarations","parameters":[{"name":"onlyEav","in":"query","description":"Should only EAV types be returned?","required":false,"schema":{"type":"boolean","default":false}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"string","format":"binary"}}}}}}}}}
```

## GET /cmn/scripting/script/runs/{runId}

>

```json
{"openapi":"3.1.0","info":{"title":"OpenAPI definition","version":"2026.42.0"},"tags":[{"name":"Scripting","description":"Script management"}],"servers":[{"url":"api.example.com"}],"paths":{"/cmn/scripting/script/runs/{runId}":{"get":{"tags":["Scripting"],"operationId":"getRunById","parameters":[{"name":"runId","in":"path","required":true,"schema":{"type":"integer","format":"int64"}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/common-scripting-ScriptRun"}}}}}}}},"components":{"schemas":{"common-scripting-ScriptRun":{"properties":{"version":{"type":"string","description":"Version Identifier for this Object (for PUT)"},"info":{"$ref":"#/components/schemas/core-api-MetaInfo"},"id":{"type":"string","description":"Unique identifier of the Object"},"script":{"$ref":"#/components/schemas/common-scripting-Script"},"identifier":{"type":"string","description":"Session identifier.","maxLength":255,"minLength":0},"logLines":{"type":"array","description":"Run log.","items":{"$ref":"#/components/schemas/common-task-TaskLogLine"}},"startedAt":{"type":"string","format":"date-time","description":"Start time."},"finishAt":{"type":"string","format":"date-time","description":"End time."},"successful":{"type":"boolean","default":true,"description":"Was the run successful?"}},"required":["finishAt","identifier","script","startedAt"]},"core-api-MetaInfo":{"description":"MetaInformations for this Object","properties":{"createdAt":{"type":"string","format":"date-time","description":"Created At Timestamp","readOnly":true},"createdFrom":{"type":"string","description":"TenantUser-Identifier of the creator","readOnly":true},"updatedAt":{"type":"string","format":"date-time","description":"Last Updated AT Timestamp","readOnly":true},"updatedFrom":{"type":"string","description":"TenantUser-Identifier of most recent updater","readOnly":true}}},"common-scripting-Script":{"description":"Script","properties":{"version":{"type":"string","description":"Version Identifier for this Object (for PUT)"},"info":{"$ref":"#/components/schemas/core-api-MetaInfo"},"id":{"type":"string","description":"Unique identifier of the Object"},"moduleName":{"type":"string","description":"Script module name.","minLength":1},"scriptSource":{"type":"string","description":"Script to execute.","maxLength":2147483647,"minLength":0},"scriptModuleRef":{"$ref":"#/components/schemas/core-api-ApiObjectReference"}},"required":["moduleName"]},"core-api-ApiObjectReference":{"description":"Parent category.","properties":{"id":{"type":"string","description":"Identifier"},"label":{"type":"string","description":"a label","readOnly":true},"description":{"type":"string","description":"a short description","readOnly":true},"active":{"type":"boolean","description":"Active.","readOnly":true}},"required":["id"]},"common-task-TaskLogLine":{"description":"Log entries.","properties":{"version":{"type":"string","description":"Version Identifier for this Object (for PUT)"},"info":{"$ref":"#/components/schemas/core-api-MetaInfo"},"id":{"type":"string","description":"Unique identifier of the Object"},"logTime":{"type":"string","format":"date-time","description":"logTime","readOnly":true},"origin":{"type":"string","description":"log level","enum":["DEBUG","INFO","WARNING","ERROR","CONSOLE","STACKTRACE"],"readOnly":true},"message":{"$ref":"#/components/schemas/core-api-LocalizeableMessage"}}},"core-api-LocalizeableMessage":{"description":"localizeable message","properties":{"messageCode":{"type":"string","description":"Internal unique identifier/key for this message"},"messageParameters":{"type":"object","additionalProperties":{"type":"object","description":"list of parameters to fill a formattable message"},"description":"list of parameters to fill a formattable message"},"formattedMessage":{"type":"string","description":"formatted message (default language)"}}}}}}
```

## GET /cmn/scripting/script/module/{module}/script-context-description

>

```json
{"openapi":"3.1.0","info":{"title":"OpenAPI definition","version":"2026.42.0"},"tags":[{"name":"Scripting","description":"Script management"}],"servers":[{"url":"api.example.com"}],"paths":{"/cmn/scripting/script/module/{module}/script-context-description":{"get":{"tags":["Scripting"],"operationId":"getScriptContextDescription","parameters":[{"name":"module","in":"path","required":true,"schema":{"type":"string"}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/core-scripting-ScriptDescription"}}}}}}}},"components":{"schemas":{"core-scripting-ScriptDescription":{"description":"Script description.","properties":{"mainInstance":{"$ref":"#/components/schemas/core-scripting-ScriptingInstanceDescription"},"availableTypes":{"type":"array","description":"Available type descriptions.","items":{"$ref":"#/components/schemas/core-scripting-ScriptingTypeDescription"}},"availableInput":{"type":"array","description":"Available input data.","items":{"$ref":"#/components/schemas/core-scripting-ScriptInputDescription"}}}},"core-scripting-ScriptingInstanceDescription":{"description":"Description of an instance used in scripting.","properties":{"name":{"type":"string","description":"Type name."},"description":{"type":"string","description":"Type description."},"moduleName":{"type":"string","description":"Name of the module where this instance is defined."},"attributes":{"type":"array","description":"Type attributes.","items":{"$ref":"#/components/schemas/core-scripting-ScriptingTypeAttributeDescription"}},"methods":{"type":"array","description":"Type methods.","items":{"$ref":"#/components/schemas/core-scripting-ScriptingTypeMethodDescription"}},"usageExample":{"type":"string","description":"Usage example."},"type":{"type":"string","description":"Type of the scripting type.","enum":["INSTANCE","SERVICE","DTO","EAV","ENUM","ARRAY","MAP","CALLBACK","METHOD"]}}},"core-scripting-ScriptingTypeAttributeDescription":{"description":"Description of an attribute of an object used in scripting.","properties":{"name":{"type":"string","description":"Attribute name."},"description":{"type":"string","description":"Attribute description."},"readOnly":{"type":"boolean","default":false,"description":"Is the attribute read-only?"},"dataType":{"type":"string","description":"Attribute data type."},"dataTypeName":{"type":"string","description":"For data type \"object\": the object description."}}},"core-scripting-ScriptingTypeMethodDescription":{"description":"Description of a method of an object used in scripting.","properties":{"name":{"type":"string","description":"Method name."},"description":{"type":"string","description":"Method description."},"returnType":{"type":"string","description":"Method return type."},"returnTypeName":{"type":"string","description":"For data type \"object\": the return type name."},"returnDescription":{"type":"string","description":"Return value description."},"parameters":{"type":"array","description":"Method parameters.","items":{"$ref":"#/components/schemas/core-scripting-ScriptingTypeMethodParameterDescription"}},"type":{"type":"string","description":"Type of the scripting type.","enum":["INSTANCE","SERVICE","DTO","EAV","ENUM","ARRAY","MAP","CALLBACK","METHOD"]},"dataTypeName":{"type":"string"},"dataType":{"type":"string"}}},"core-scripting-ScriptingTypeMethodParameterDescription":{"description":"Description of a parameter of a method of an object used in scripting.","properties":{"name":{"type":"string","description":"Parameter name."},"description":{"type":"string","description":"Parameter description."},"nonNull":{"type":"boolean","default":false,"description":"Is the parameter defined as \"non-null\"?"},"dataType":{"type":"string","description":"Parameter data type."},"dataTypeName":{"type":"string","description":"For data type \"object\": the parameter type name."}}},"core-scripting-ScriptingTypeDescription":{"description":"Available type descriptions.","properties":{"name":{"type":"string","description":"Type name."},"description":{"type":"string","description":"Type description."},"type":{"type":"string","description":"Type of the scripting type.","enum":["INSTANCE","SERVICE","DTO","EAV","ENUM","ARRAY","MAP","CALLBACK","METHOD"]}}},"core-scripting-ScriptInputDescription":{"description":"Input parameter description.","properties":{"name":{"type":"string","description":"Parameter name."},"description":{"type":"string","description":"Parameter description."},"dataType":{"type":"string","description":"Parameter data type."},"dataTypeName":{"type":"string","description":"For data type \"object\": the parameter type."}}}}}}
```

## GET /cmn/scripting/script/module

>

```json
{"openapi":"3.1.0","info":{"title":"OpenAPI definition","version":"2026.42.0"},"tags":[{"name":"Scripting","description":"Script management"}],"servers":[{"url":"api.example.com"}],"paths":{"/cmn/scripting/script/module":{"get":{"tags":["Scripting"],"operationId":"getModules","responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"type":"string"}}}}}}}}}}
```

## GET /cmn/scripting/markdown-documentation

>

```json
{"openapi":"3.1.0","info":{"title":"OpenAPI definition","version":"2026.42.0"},"tags":[{"name":"Scripting","description":"Script management"}],"servers":[{"url":"api.example.com"}],"paths":{"/cmn/scripting/markdown-documentation":{"get":{"tags":["Scripting"],"operationId":"getMarkdownDocumentation","responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"string","format":"binary"}}}}}}}}}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://developer.vario-software.de/api-reference/scripting.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
